%global leapp_datadir %{_datadir}/leapp-repository
%global repositorydir %{leapp_datadir}/repositories
%global custom_repositorydir %{leapp_datadir}/custom-repositories

%define leapp_repo_deps  9
%define leapp_python_sitelib %{python3_sitelib}
%define lpr_name leapp-upgrade-oc8to9
%global __requires_exclude ^python\\(abi\\) = 3\\..+|/usr/libexec/platform-python|/usr/bin/python.*

Name:           leapp-repository
Version:        0.18.1
Release:        8.oc8
Summary:        Repositories for leapp

License:        ASL 2.0
URL:            https://oamg.github.io/leapp/
Source0:        https://github.com/oamg/%{name}/archive/v%{version}.tar.gz#/%{name}-%{version}.tar.gz
Source1:        deps-pkgs-9.tar.gz
BuildArch:      noarch

%description
%{summary}

%package -n %{lpr_name}
Summary: Leapp repositories for the in-place upgrade

BuildRequires:  python3-devel

Conflicts:      leapp-upgrade-el7toel8

Obsoletes:      leapp-repository < 0.14.0-5
Obsoletes:      leapp-repository-deps < 0.14.0-5

Provides:       leapp-repository = %{version}-%{release}
Provides:       leapp-upgrade = %{version}-%{release}
Provides:       leapp-command(answer)
Provides:       leapp-command(preupgrade)
Provides:       leapp-command(upgrade)
Provides:       leapp-command(rerun)
Provides:       leapp-command(list-runs)

Requires:       leapp-framework >= 3.1
Requires:       leapp
Requires:       cpio
Requires:       dnf >= 4
Requires:       pciutils
Requires:       systemd-container
Requires:       python3-pyudev
Requires:       python3-requests
Requires:       python3-six
Requires:       policycoreutils-python-utils
Requires:       procps-ng
Requires:       kmod
Requires:       dracut
Requires:       NetworkManager-libnm
Requires:       python3-gobject-base

%description -n %{lpr_name}
Leapp repositories for the in-place upgrade to the next major version
of the Red Hat Enterprise Linux system.

%prep
%setup -n %{name}-%{version}
%setup -q  -n %{name}-%{version} -D -T -a 1

%build
cp -a leapp*deps*el9.noarch.rpm repos/system_upgrade/oc8tooc9/files/bundled-rpms/

%install
install -m 0755 -d %{buildroot}%{custom_repositorydir}
install -m 0755 -d %{buildroot}%{repositorydir}
cp -r repos/* %{buildroot}%{repositorydir}/

chmod -R 777 %{buildroot}%{repositorydir}/system_upgrade/common/actors/commonleappdracutmodules/files/
chmod -R 777 %{buildroot}%{repositorydir}/system_upgrade/common/actors/initramfs/upgradeinitramfsgenerator/files/
chmod -R 777 %{buildroot}%{repositorydir}/system_upgrade/common/tools/
chmod -R 777 %{buildroot}%{repositorydir}/system_upgrade/oc8tooc9/tools/

install -m 0755 -d %{buildroot}%{_sysconfdir}/leapp/repos.d/
install -m 0755 -d %{buildroot}%{_sysconfdir}/leapp/transaction/
install -m 0755 -d %{buildroot}%{_sysconfdir}/leapp/files/
install -m 0644 etc/leapp/transaction/* %{buildroot}%{_sysconfdir}/leapp/transaction

install -m 0755 -d %{buildroot}%{_sysconfdir}/yum.repos.d/
install -m 0644 etc/leapp/files/* %{buildroot}%{_sysconfdir}/leapp/files
install -m 0644 etc/yum.repos.d/* %{buildroot}%{_sysconfdir}/yum.repos.d

install -m 0755 -d %{buildroot}%{leapp_python_sitelib}/leapp/cli/
cp -r commands %{buildroot}%{leapp_python_sitelib}/leapp/cli/
rm -rf %{buildroot}%{leapp_python_sitelib}/leapp/cli/commands/tests
rm -rf %{buildroot}%{repositorydir}/system_upgrade/el7tooc8
rm -rf %{buildroot}%{repositorydir}/common/actors/testactor
find %{buildroot}%{repositorydir}/common -name "test.py" -delete
rm -rf `find %{buildroot}%{repositorydir} -name "tests" -type d`
find %{buildroot}%{repositorydir} -name "Makefile" -delete
find %{buildroot} -name "*.py.orig" -delete

for DIRECTORY in $(find  %{buildroot}%{repositorydir}/  -mindepth 1 -maxdepth 1 -type d);
do
    REPOSITORY=$(basename $DIRECTORY)
    echo "Enabling repository $REPOSITORY"
    ln -s  %{repositorydir}/$REPOSITORY  %{buildroot}%{_sysconfdir}/leapp/repos.d/$REPOSITORY
done;

%py_byte_compile %{__python3} %{buildroot}%{repositorydir}/*

%files -n %{lpr_name}
%doc README.md
%license LICENSE
%dir %{_sysconfdir}/leapp/transaction
%dir %{_sysconfdir}/leapp/files
%dir %{leapp_datadir}
%dir %{repositorydir}
%dir %{custom_repositorydir}
%dir %{leapp_python_sitelib}/leapp/cli/commands
%config %{_sysconfdir}/leapp/files/*
%{_sysconfdir}/leapp/repos.d/*
%{repositorydir}/*
%{leapp_python_sitelib}/leapp/cli/commands/*
%{_sysconfdir}/leapp/transaction/*
%{_sysconfdir}/yum.repos.d/*

%changelog
* Fri Jan 17 2025 xiaoyunzhao <xiaoyunzhao@tencent.com> - 0.18.1-8
- bugfix: fix the bug that can upgrade when os installed libpq-devel and postgresql-server-devel

* Mon Jan 13 2025 xiaoyunzhao <xiaoyunzhao@tencent.com> - 0.18.1-7
- bugfix: fix the bug that can not enter new kernel

* Tue Jan 7 2025 xiaoyunzhao <xiaoyunzhao@tencent.com> - 0.18.1-6
- bugfix: fix the bug that the upgrade failed because of grubenv

* Thu Jan 2 2025 xiaoyunzhao <xiaoyunzhao@tencent.com> - 0.18.1-5
- bugfix:rust-doc

* Thu Dec 19 2024 xiaoyunzhao <xiaoyunzhao@tencent.com> - 0.18.1-4
- support graphical upgrade

* Thu Dec 19 2024 xiaoyunzhao <xiaoyunzhao@tencent.com> - 0.18.1-3
- support aarch64

* Tue Aug 20 2024 xiaoyunzhao <xiaoyunzhao@tencent.com> - 0.18.1-2
- support OpenCloudOS 8.8/8.6 to 9.2

* Fri Oct 13 2023 xiaoyunzhao <xiaoyunzhao@tencent.com> - 0.18.1-1
- modify for OpenCloudOS
